How to keep single pane open always in Angular Accordion

26 Sep 20266 minutes to read

By default, all Angular Accordion panels in the Syncfusion Angular Accordion component are collapsible in Single expand mode. The Angular Accordion can be configured to always keep one panel in an expanded state, ensuring at least one content section remains visible. This is useful for scenarios requiring a default content display, such as highlighting key information or maintaining a consistent UI. This is applicable for Single expand mode.
The example below demonstrates an Angular Accordion with one pane always expanded in Single mode.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { AccordionModule } from '@syncfusion/ej2-angular-navigations'



import { Component, ViewChild } from '@angular/core';
import { AccordionComponent } from '@syncfusion/ej2-angular-navigations';
import {ExpandEventArgs, AccordionClickArgs} from '@syncfusion/ej2-navigations';

@Component({
imports: [
         AccordionModule
    ],


standalone: true,
    selector: 'app-container',
    template: `
    <ejs-accordion #element expandMode='Single' (expanding)="beforeExpand($event)" (clicked)="clicked($event)">
        <e-accordionitems>
          <e-accordionitem expanded='true'>
            <ng-template #header>
              <div>ASP.NET</div>
            </ng-template>
            <ng-template #content>
              <div>Microsoft ASP.NET is a set of technologies in the Microsoft .NET Framework for building Web applications and XML Web
                services. ASP.NET pages execute on the server and generate markup such as HTML, WML, or XML that is sent to a desktop
                or mobile browser. ASP.NET pages use a compiled,event-driven programming model that improves performance and enables
                the separation of application logic and user interface.</div>
            </ng-template>
          </e-accordionitem>
          <e-accordionitem>
            <ng-template #header>
              <div>ASP.NET MVC</div>
            </ng-template>
            <ng-template #content>
              <div>The Model-View-Controller (MVC) architectural pattern separates an application into three main components: the model,
                the view, and the controller. The ASP.NET MVC framework provides an alternative to the ASP.NET Web Forms pattern for
                creating Web applications. The ASP.NET MVC framework is a lightweight, highly testable presentation framework that
                (as with Web Forms-based applications) is integrated with existing ASP.NET features, such as master pages and membership-based
                authentication.
              </div>
            </ng-template>
          </e-accordionitem>
          <e-accordionitem>
            <ng-template #header>
              <div>JavaScript</div>
            </ng-template>
            <ng-template #content>
              <div>JavaScript (JS) is an interpreted computer programming language.It was originally implemented as part of web browsers
                so that client-side scripts could interact with the user, control the browser, communicate asynchronously, and alter
                the document content that was displayed.More recently, however, it has become common in both game development and
                the creation of desktop applications.</div>
            </ng-template>
          </e-accordionitem>
        </e-accordionitems>
    </ejs-accordion>
        `
})

export class AppComponent {
    @ViewChild('element') acrdnInstance?: AccordionComponent;
    public clickEle?: HTMLElement;
    public clicked(e: AccordionClickArgs) {
    this.clickEle = ((e.originalEvent as Event).target as Element).closest(
      '.e-acrdn-header'
    ) as HTMLElement;
  }
  public beforeExpand(e: ExpandEventArgs): void {
    const childrenArray = Array.from((this.acrdnInstance as AccordionComponent).element.children);
    const expandCount = childrenArray.filter(el => el.classList.contains('e-selected')).length;
    let ele = childrenArray.filter(el => el.classList.contains('e-selected'))[0];
    if (ele) {
      ele = ele.firstChild as Element;
    }
    if (expandCount === 1 && ele === this.clickEle) {
      e.cancel = true;
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to keep a single pane open in React Accordion

04 Sep 20269 minutes to read

By default, all React Accordion panels are collapsible. You can customize the React Accordion to keep one panel as expanded state always. This is applicable for Single expand mode.

import * as React from "react";
import { useState, useRef } from "react";
import * as ReactDOM from "react-dom";
import { AccordionComponent, AccordionItemsDirective, AccordionItemDirective } from '@syncfusion/ej2-react-navigations';
const ReactApp = () => {
  const acrdnInstance = useRef(null);
  const [clickEle, setClickEle] = useState(null);
  const expanding = (e) => {
    if (acrdnInstance.current) {
      let expandCount = acrdnInstance.current.element.querySelectorAll('.e-selected').length;
      let ele = acrdnInstance.current.element.querySelectorAll('.e-selected')[0];
      if (ele) {
        ele = ele.firstChild;
      }
      if (expandCount === 1 && ele === clickEle) {
        e.cancel = true;
      }
    }
  }
  const clicked = (e) => {
    setClickEle((e.originalEvent.target).closest('.e-acrdn-header'));
  }

  const aspContent = () => {
    return (<div>
      Microsoft ASP.NET is a set of technologies in the Microsoft .NET Framework for building Web applications and XML Web services.
    </div>);
  }

  const mvcContent = () => {
    return (<div>
      The Model-View-Controller (MVC) architectural pattern separates an application into three main components: the model, the view, and the controller.
    </div>);
  }

  const jsContent = () => {
    return (<div>
      JavaScript (JS) is an interpreted computer programming language.It was originally implemented as part of web browsers so that client-side scripts could interact with the user, control the browser, communicate asynchronously, and alter the document content that was displayed.
    </div>);
  }

  return (
    <AccordionComponent ref={acrdnInstance} expandMode='Single' clicked={clicked} expanding={expanding}>
      <AccordionItemsDirective>
        <AccordionItemDirective expanded={true} header='ASP.NET' content={aspContent} />
        <AccordionItemDirective header='ASP.NET MVC' content={mvcContent} />
        <AccordionItemDirective header='JavaScript' content={jsContent} />
      </AccordionItemsDirective>
    </AccordionComponent>
  );
}

const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import * as React from "react";
import { useState, useRef } from "react";
import * as ReactDOM from "react-dom";
import { AccordionComponent, AccordionItemsDirective, AccordionItemDirective } from '@syncfusion/ej2-react-navigations';
import { ExpandEventArgs, AccordionClickArgs } from '@syncfusion/ej2-navigations';
const ReactApp = () => {
  const acrdnInstance = useRef<AccordionComponent>(null);
  const [clickEle, setClickEle] = useState(null);
  const expanding = (e: ExpandEventArgs) => {
    if (acrdnInstance.current) {
      let expandCount: number = acrdnInstance.current.element.querySelectorAll('.e-selected').length;
      let ele: HTMLElement = acrdnInstance.current.element.querySelectorAll('.e-selected')[0] as HTMLElement;
      if (ele) {
        ele = ele.firstChild as HTMLElement;
      }
      if (expandCount === 1 && ele === clickEle) {
        e.cancel = true;
      }
    }
  }
  const clicked = (e: AccordionClickArgs) => {
    setClickEle((e.originalEvent.target as Element).closest('.e-acrdn-header'));
  }
  const aspContent = () => {
    return (<div>
      Microsoft ASP.NET is a set of technologies in the Microsoft .NET Framework for building Web applications and XML Web services.
    </div>);
  }

  const mvcContent = () => {
    return (<div>
      The Model-View-Controller (MVC) architectural pattern separates an application into three main components: the model, the view, and the controller.
    </div>);
  }

  const jsContent = () => {
    return (<div>
      JavaScript (JS) is an interpreted computer programming language.It was originally implemented as part of web browsers so that client-side scripts could interact with the user, control the browser, communicate asynchronously, and alter the document content that was displayed.
    </div>);
  }

  return (
    <AccordionComponent ref={acrdnInstance} expandMode='Single' clicked={clicked} expanding={expanding}>
      <AccordionItemsDirective>
        <AccordionItemDirective expanded={true} header='ASP.NET' content={aspContent} />
        <AccordionItemDirective header='ASP.NET MVC' content={mvcContent} />
        <AccordionItemDirective header='JavaScript' content={jsContent} />
      </AccordionItemsDirective>
    </AccordionComponent>
  );
}

const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 React Accordion Sample</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/tailwind3.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='element'>
        <div id='loader'>Loading....</div></div>
</body>
</html>

How to keep single pane open always in Vue Accordion

20 Aug 20265 minutes to read

By default, all Accordion panels are collapsible. You can customize the Accordion to keep one panel as expanded state always. This is applicable for Single expand mode.

<template>
  <div id="app">
    <ejs-accordion ref="element" expandMode='Single' :expanding="beforeExpand" :clicked="clicked">
      <e-accordionitems>
        <e-accordionitem expanded='true' header='ASP.NET'
          content='Microsoft ASP.NET is a set of technologies in the Microsoft .NET Framework for building Web applications and XML Web services'></e-accordionitem>
        <e-accordionitem header='ASP.NET MVC'
          content='The Model-View-Controller (MVC) architectural pattern separates an application into three main components: the model, the view, and the controller.'></e-accordionitem>
        <e-accordionitem header='JavaScript'
          content='JavaScript (JS) is an interpreted computer programming language.It was originally implemented as part of web browsers so that client-side scripts could interact with the user, control the browser, communicate asynchronously, and alter the document content that was displayed.'></e-accordionitem>
      </e-accordionitems>
    </ejs-accordion>
  </div>
</template>
<script setup>

import { AccordionComponent as EjsAccordion, AccordionItemDirective as EAccordionitem, AccordionItemsDirective as EAccordionitems } from "@syncfusion/ej2-vue-navigations";
import { ref } from 'vue';

var clickEle;
const element = ref(null);
const clicked = (e) => {
  clickEle = e.originalEvent.target.closest('.e-acrdn-header');
};
const beforeExpand = (e) => {
  var obj = element.value.ej2Instances;
  var expandCount = obj.element.querySelectorAll('.e-selected').length;
  var ele = obj.element.querySelectorAll('.e-selected')[0];
  if (ele) {
    ele = ele.firstChild
  }
  if (expandCount === 1 && ele === clickEle) {
    e.cancel = true;
  }
};

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>
<template>
  <div id="app">
    <ejs-accordion ref="element" expandMode='Single' :expanding="beforeExpand" :clicked="clicked">
      <e-accordionitems>
        <e-accordionitem expanded='true' header='ASP.NET'
          content='Microsoft ASP.NET is a set of technologies in the Microsoft .NET Framework for building Web applications and XML Web services'></e-accordionitem>
        <e-accordionitem header='ASP.NET MVC'
          content='The Model-View-Controller (MVC) architectural pattern separates an application into three main components: the model, the view, and the controller.'></e-accordionitem>
        <e-accordionitem header='JavaScript'
          content='JavaScript (JS) is an interpreted computer programming language.It was originally implemented as part of web browsers so that client-side scripts could interact with the user, control the browser, communicate asynchronously, and alter the document content that was displayed.'></e-accordionitem>
      </e-accordionitems>
    </ejs-accordion>
  </div>
</template>
<script>

import { AccordionComponent, AccordionItemDirective, AccordionItemsDirective } from '@syncfusion/ej2-vue-navigations';

var clickEle;
export default {
  name: "App",
  components: {
    "ejs-accordion": AccordionComponent,
    "e-accordionitems": AccordionItemsDirective,
    "e-accordionitem": AccordionItemDirective
  },
  methods: {
    clicked: function (e) {
      clickEle = e.originalEvent.target.closest('.e-acrdn-header');
    },
    beforeExpand: function (e) {
      var obj = this.$refs.element.ej2Instances;
      var expandCount = obj.element.querySelectorAll('.e-selected').length;
      var ele = obj.element.querySelectorAll('.e-selected')[0];
      if (ele) {
        ele = ele.firstChild
      }
      if (expandCount === 1 && ele === clickEle) {
        e.cancel = true;
      }
    },
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>